//////////////////////////////////////////
//
// gcc -W -Wall -Os -o sugarize sugarize.c
//

#ifndef ACTIVITY
#define ACTIVITY "a.out"
#endif

#ifndef ACTIVITY_FULL
#define ACTIVITY_FULL "%s/%s"
#endif

#ifndef ARGS
#define ARGS
#endif

#ifndef LIBRARY
#define LIBRARY "libsugarize.so"
#endif

#ifndef LIBRARY_FULL
#define LIBRARY_FULL "%s/%s"
#endif

// can also define NET_WM_NAME as a string to be used

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

int main(int argc, char *argv[])
{
FILE *fp = fopen("/home/olpc/garply","w");

	int pos = 1;
    while (argv[pos]) {
	fprintf(fp, "%s\n", argv[pos++]);
    }
    fclose(fp);
	if(argc<5)
		exit(33);
    pos=1;
	while(argv[pos]){
		if(argv[pos][0]!='-' || !argv[pos][1] || argv[pos][2] || !argv[pos+1] || !argv[pos+1][0])
			exit(11);
		switch(argv[pos][1]){
		case 'a':
			setenv("SUGAR_ACTIVITY_ID", argv[pos+1], 0);
			pos += 2;
			continue;
		case 'b':
			setenv("SUGAR_BUNDLE_ID", argv[pos+1], 0);
			pos += 2;
			continue;
		case 'o':
			setenv("SUGAR_OBJECT_ID", argv[pos+1], 0);
			pos += 2;
			continue;
		case 'u':
			setenv("SUGAR_URI", argv[pos+1], 0);
			pos += 2;
			continue;
		default:
			;
		}
		exit(22);
	}

#ifdef NET_WM_NAME
	const char *net_wm_name = NET_WM_NAME;
#else
	const char *net_wm_name = NULL;
	if(argv[0])
		net_wm_name = strrchr(argv[0],'/');
	if(net_wm_name)
		net_wm_name++;
	else
		net_wm_name = argv[0];
	if(!net_wm_name)
		net_wm_name = "no-name-activity";
#endif
	setenv("NET_WM_NAME", net_wm_name, 0);

	const char *sbp = getenv("SUGAR_BUNDLE_PATH");
	if(!sbp)
		sbp = ".";
	char ap[999];
	snprintf(ap,sizeof ap,ACTIVITY_FULL,sbp,ACTIVITY);
	char lp[999];
	snprintf(lp,sizeof lp,LIBRARY_FULL,sbp,LIBRARY);
	
	printf("%s %s\n", lp, ap);
    fprintf(fp, "lib=%s   act=%s\n",lp,ap);
    fclose(fp);
	setenv("LD_PRELOAD", lp, 0);
	execlp(ap, net_wm_name, ARGS (char*)NULL);
	return 77;
}
//////////////////
